/*____________________________________________*\
*                                              *
*                                              *
*                -= vida =-                    *
*       Visual Interactive Datapipe            *
*               no (c) 2002                    *
*                  v.0.7.1                     *
*                                              *
*    coded by                                  *
*    embyte -> embyte@madlab.it                *
*    lesion -> lesion@autisti.org              *
*                                              *
*    less README for features and more info    *
*                                              *
*    --------------------------------------    *
*                                              *
*    include.h:                                *
*      -declare includes                       *
*      -define some vars                       *
*      -declare some needed structs            *
*      -declare global vars                    *
*      -do prototype of functions              *
*                                              *
*                                              *
\*____________________________________________*/

#include <sys/socket.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <netinet/in.h>
#include <netdb.h>
#include <string.h>
#include <malloc.h>
#include <errno.h>
#include <unistd.h>
#include <sys/types.h>
#include <curses.h>
#include <signal.h>
#include <pthread.h>

/*
 * includes for dnshijacking
 */
#include <libnet.h>
#include <pcap.h>

#define VERSION "0.7.1"
#define MAXLINE 1029

struct pswadmin {
   char check;    // datapipe have psw?
   char psw[32];
};


struct redirect
{

  int localport;
  int remoteport;
  char *host;

  // numero di connessioni di questo datapipe
  int cn;

  // connessioni di questo datapipe (host)
  char *ch[10];

  // connessioni di questo datapipe (port)
  int cp[10];

  // byte ricevuti
  long int rb[10];

  // byte trasmessi
  long int tb[10];

  int from_sd[10];
  int dest_sd[10];
  struct sockaddr_in sout;

  /*
   * status value: 
   0- print "client" data 
   1- print "server" data 
   2- print all data 
   3- print all data in different color 
   4- print "matched" data
   ---- 
   5-hijacking (keep client)
   6-hijacking (keep server) 
   7-hijacking (keep both) (skleroooooooooooo)
   8-closing this connection
   */
  int status[10];
  int logfile[10]; 
  int stat;
   
   // struct psw 
   struct pswadmin pswadm;
}
dp[10];

// numero di datapipe presenti
int ndp;

// stringa che deve metchare nello sniffing (max 200 byte)
char mstring[200];

// log stream
FILE *fout;

pthread_t dp_thread[10], h;

// le finestre
WINDOW *wmenu, *wlist, *wdata;

// win indica dove si trova il focus, 
// 0 = wmenu, 1 = wlist (list datapipe), 2 = wlist (list connection)
int win;

// mpos indica la posizione del cursore nel menu
// dpos indica la posizione del cursore nella lista dei datapipe
// cpos indica la posizione del cursore nella lista delle connessioni
ushort mpos, dpos, cpos;



// resta in accept...e passa le connessioni ad handler
void datapipe();
void handler(int *io);

// free all
void finish();

// erase \r from string
void normal(char *s, int len);
void statzero();

void info(const char *s);


/*
 * ripped and riadacted from dnshijacker v1.2 by pedram amini
 * (pedram@redhive.com) www.redhive.com 
 */




/*
 * defines 
 */
#define SNAPLEN    128
#define PROMISC      1
#define T_A          1          /* host address */


/*
 * our chewycenter ... holds important information 
 */
struct cc
{
  u_long src_address;           /* source address */
  u_long dst_address;           /* destination address */
  u_short src_port;             /* source port */
  u_short dst_port;             /* destination port */
  u_short dns_id;               /* dns id */
  int is_a;                     /* are we an A */
  int have_answer;              /* do we have an answer? */
  int payload_size;             /* size of our payload */
  u_char payload[512];          /* payload storage */
  char current_question[128];   /* current question being asked */
  char *current_answer;         /* current answer we are using */
}
cc;



int offset;                     /* datalink offset */

void parse_dns(char *);         /* parse a packet, build an answer */
pcap_t *set_cap_dev(char *, char *); /* set capdev up to capture dns */
void spoof_dns(int);            /* spoof a dns packet */


/*
 * dns packet header |--- 1 byte ----|
 * +---------------|---------------|---------------|---------------+ | DNS ID 
 * | QR,OP,AA,TC,RD|RA,0,AD,CD,CODE|
 * |---------------|---------------|---------------|---------------| | #
 * Questions | # Answers |
 * |---------------|---------------|---------------|---------------| | #
 * Authority | # Resource |
 * +---------------|---------------|---------------|---------------+ 
 */

struct dnshdr
{
  unsigned id:16;               /* query identification number */
  unsigned rd:1;                /* recursion desired */
  unsigned tc:1;                /* truncated message */
  unsigned aa:1;                /* authoritative answer */
  unsigned opcode:4;            /* purpose of message */
  unsigned qr:1;                /* response flag */
  unsigned rcode:4;             /* response code */
  unsigned cd:1;                /* checking disabled by resolver */
  unsigned ad:1;                /* authentic data from named */
  unsigned unused:1;            /* unused bits (MBZ as of 4.9.3a3) */
  unsigned ra:1;                /* recursion available */
  unsigned qdcount:16;          /* number of question entries */
  unsigned ancount:16;          /* number of answer entries */
  unsigned nscount:16;          /* number of authority entries */
  unsigned arcount:16;          /* number of resource entries */
};
